//+------------------------------------------------------------------+
//|                                         TEST_FileWriteStruct.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

#include <stderror.mqh>

struct ORD {
    int      OINDEX;      // INDEX
    int      OTICKET;     // OrderTicket
    string   OSYMBOL;     // OrderSymbol
    int      OTYPE;       // OrderType
    double   OOP;         // OrderOpenPrice
    datetime OOT;         // OrderOpenTime
    double   OLOTS;       // OrderLots
    double   OSL;         // OrderStopLoss
    double   OTP;         // OrderTakeProfit
    double   OPROFIT;     // OrderProfit
    double   OCP;         // OrderClosePrice
    datetime OCT;         // OrderCloseTime
    double   OCOMMISSION; // OrderCommission
    double   OSWAP;       // OrdeSwap    
    int      OMN;         // OrderMagicNumber
    datetime OEXPIRATION; // OrderExpiration
    string   OCOMMENT;    // OrderComment
    double   OMLP;        // OrderMinLotPrice 
    double   OMPP;        // OrderMaxProfitPrice
};
ORD          Orders[100];

//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart(){
   for (int  i = 0; i < OrdersTotal(); i++){
      if (OrderSelect( i, SELECT_BY_POS, MODE_TRADES )){
        Orders[i].OINDEX      = i;
        Orders[i].OTICKET     = OrderTicket(); 
        Orders[i].OSYMBOL     = OrderSymbol();
        Orders[i].OTYPE       = OrderType();
        Orders[i].OOP         = OrderOpenPrice();
        Orders[i].OOT         = OrderOpenTime();
        Orders[i].OLOTS       = OrderLots();
        Orders[i].OSL         = OrderStopLoss();
        Orders[i].OTP         = OrderTakeProfit();
        Orders[i].OPROFIT     = OrderProfit();
        Orders[i].OCP         = OrderClosePrice();
        Orders[i].OCT         = OrderCloseTime();
        Orders[i].OCOMMISSION = OrderCommission();
        Orders[i].OSWAP       = OrderSwap();
        Orders[i].OMN         = OrderMagicNumber();
        Orders[i].OEXPIRATION = OrderExpiration();
        Orders[i].OCOMMENT    = OrderComment();
       }
   }  
 /* 
  //  1.   
  FWS( Orders );
  
  //  2.  
  int i,FWS, FD;
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN );
  for( i = 0; i < ArraySize( Orders ); i++ ){ 
    FWS = FileWriteStruct ( FD, Orders[i]);          //   'Orders' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	69	33
  }
  FileClose(FD);
  
  //  3.  
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN );
  FWS = FileWriteStruct ( FD, Orders );          //   'Orders' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	75	31
  FileClose(FD);
*/
  POAC( Orders );
}
//+------------------------------------------------------------------+[SCR END]

/*
//   
void FWS( ORD &l_ord[] ){
  int i,FWS, FD;
  FD = FileOpen( "Orders.dat", FILE_READ|FILE_WRITE|FILE_BIN|FILE_COMMON );
  for( i = 0; i < ArraySize( l_ord ); i++ ){ 
      FWS = FileWriteStruct ( FD, l_ord[i]); //   'l_ord' - parameter conversion not allowed	TEST_FileWriteStruct.mq4	88	35
  }
  FileClose(FD);
}
*/
//
// Print Orders After Copying    
// 
void POAC ( ORD &l_OP[] ){     
   string TXT;
   for (int i = 0; i < OrdersTotal(); i++){      //   ,  
     TXT = "[POAC][" +
     IntegerToString ( l_OP[i].OINDEX, 3)                                           + "][" +
     IntegerToString ( l_OP[i].OTICKET, 10)                                         + "][" +
                       l_OP[i].OSYMBOL                                              + "][" +
     IntegerToString ( l_OP[i].OTYPE, 1)                                            + "][" +
     DoubleToStr     ( l_OP[i].OOP,     MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     TimeToString    ( l_OP[i].OOT,     TIME_DATE|TIME_SECONDS)                     + "][" +
     DoubleToStr     ( l_OP[i].OLOTS,   MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     DoubleToStr     ( l_OP[i].OSL,     MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     DoubleToStr     ( l_OP[i].OTP,     MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     DoubleToStr     ( l_OP[i].OPROFIT, MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     DoubleToStr     ( l_OP[i].OCP,     MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     TimeToString    ( l_OP[i].OCT,     TIME_DATE|TIME_SECONDS)                     + "][" +
                       l_OP[i].OCOMMISSION                                          + "][" +
     DoubleToStr     ( l_OP[i].OSWAP,   MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     IntegerToString ( l_OP[i].OMN, 10)                                             + "][" +
     TimeToString    ( l_OP[i].OEXPIRATION, TIME_DATE|TIME_SECONDS)                 + "][" +
                       l_OP[i].OCOMMENT                                             + "][" +
     DoubleToStr     ( l_OP[i].OMLP,    MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "][" +
     DoubleToStr     ( l_OP[i].OMPP,    MarketInfo( l_OP[i].OSYMBOL, MODE_DIGITS))  + "]" ;      
     Print( TXT );       
    }
}